unit USample;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Forms,
  Vcl.Graphics, Vcl.Dialogs, Vcl.Controls, AdvCustomControl, AdvWebBrowser, Vcl.StdCtrls;

type
  TForm24 = class(TForm)
    Button1: TButton;
    AdvWebBrowser1: TAdvWebBrowser;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form24: TForm24;

implementation

{$R *.dfm}

uses
  AdvWebBrowser.Win, System.NetEncoding;

procedure TForm24.Button1Click(Sender: TObject);
var
  c: ICoreWebView2Controller;
  we: ICoreWebView2Environment;
  we2: ICoreWebView2Environment2;
  w: ICoreWebView2;
  w2: ICorewebview2_2;
  s: TStringStream;
  r: ICoreWebView2WebResourceRequest;
  b: TBase64Encoding;
  v: string;
begin
  c := ICoreWebView2Controller(AdvWebBrowser1.NativeBrowser);
  we := ICoreWebView2Environment(AdvWebBrowser1.NativeEnvironment);
  if (c.get_CoreWebView2(w) = S_OK) and (we.QueryInterface(IID_ICoreWebView2Environment2, we2) = S_OK) then
  begin
    if w.QueryInterface(IID_ICoreWebView2_2, w2) = S_OK then
    begin
      s := TStringStream.Create;
      s.WriteString('Hello World'); //post-data
      s.Position := 0;

      b := TBase64Encoding.Create(0);
      try
        v := b.Encode('username:password');
      finally
        b.Free;
      end;

      if we2.CreateWebResourceRequest('https://myserver.com', 'POST',
        TStreamAdapter.Create(s, soOwned), PChar('Authorization: Basic ' + v), r) = S_OK then
      begin
        w2.NavigateWithWebResourceRequest(r);
      end;
    end;
  end;
end;

end.
